
  /*       Mouse functions  supported by interrupt 0x33 for text & graphic
	   work mode  */

  #ifndef MOUSE.H
  #define MOUSE.H

  #define LEFTMK 1
  #define RIGHTMK 2
  #define MIDDLEMK 3
  #define MOUSE_TEXTMOD 0
  #define MOUSE_GRAPHMOD 1
  #include <dos.h>

  struct
   {
    int mode;
    int xx;
    int yy;
    int right;
    int middle;
    int left;
    int comb;
   } mouse;

  int initmouse(int mode);
  int outmouse(void);
  int getmouse(int button);
  int movemxy(int mx,int my);
  int rstm(void);
  int viewm(void);
  int unviewm(void);

  int initmouse(int mode)
   {
    int ppk;
     _AX=0;
     geninterrupt(0x33);
     ppk=_AX;
      if(ppk!=-1) return -1;
     viewm();
     mouse.mode=!mode;
     return 0;
   }

  int outmouse(void)
   {
     return unviewm();
   }

  int getmouse(int button)
   {
    int bx,cx,dx;
     mouse.left=0;    mouse.right=0;     mouse.middle=0;
     mouse.xx=0;      mouse.yy=0;        mouse.comb=0;
     _AX=3;
     geninterrupt(0x33);
     bx=_BX;     cx=_CX;     dx=_DX;
     mouse.xx=cx/(8*mouse.mode+!mouse.mode);
     mouse.yy=dx/(8*mouse.mode+!mouse.mode);
     mouse.comb=bx;
      switch(bx)
       {
        case 1: mouse.left=1; break;
        case 2: mouse.right=1; break;
        case 4: mouse.middle=1; break;
        case 3: mouse.left=1; mouse.right=1; break;
        case 5: mouse.left=1; mouse.middle=1; break;
        case 6: mouse.right=1; mouse.middle=1; break;
        case 7: mouse.right=1; mouse.middle=1; mouse.right=1; break;
       }
     if(button!=0)
      {
       switch(button)
        {
         case LEFTMK: return mouse.left*1;
         case RIGHTMK: return mouse.right*2;
         case MIDDLEMK: return mouse.middle*4;
        }
      }
     return 0;
   }

  int movemxy(int mx,int my)
   {
     _CX=mx;
     _DX=my;
     _AX=4;
     geninterrupt(0x33);
     return 0;
   }

  int rstm(void)
   {
     movemxy(0,0);
     return 0;
   }

  int unviewm(void)
   {
    int mr;
     _AX=2;
     geninterrupt(0x33);
     mr=_AX;
     return mr;
   }

  int viewm(void)
   {
    int mr;
     _AX=1;
     geninterrupt(0x33);
     mr=_AX;
     return mr;
   }

  #endif
